
/*
 * Copyright (c) 2019-2021, The Linux Foundation. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of The Linux Foundation nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "interface_handlers.h"

namespace adk {

PropertiesHandler::PropertiesHandler(Dbus *dbus) :
    dbus_(dbus) {
        dbus_->setPropertiesChangedListener(
        std::bind(&PropertiesHandler::propertiesChangedCb, this,
        std::placeholders::_1, std::placeholders::_2, std::placeholders::_3));
}

void PropertiesHandler::propertiesChangedCb(const std::string &obj_path,
    const std::string &iface_name, GVariantIter *iter) {
    g_print("PropertiesHandler::propertiesChangedCb \n");
    {% for iface in get_ifaces(user_def["properties"]) %}
    if (iface_name == std::string(adk::dbus::{{get_const_string_def(iface=iface)}})) {
        PropertiesAttr changed_properties = process{{get_const_string_def(iface=iface)[1:]|upper_camel_case}}Response(obj_path, iter);
        for (auto &f : properties_changed_listeners_) {
            f(changed_properties, obj_path);
        }
        return;
    }
    {% endfor %}
}

{% for iface in get_ifaces(user_def["properties"]) %}
PropertiesAttr PropertiesHandler::process{{get_const_string_def(iface=iface)[1:]|upper_camel_case}}Response(
    const std::string &obj_path, GVariantIter *iter) {
    g_print("PropertiesHandler::process{{get_const_string_def(iface=iface)|upper_camel_case}}Response obj_path: %s \n", obj_path.c_str());
    char *key;
    GVariant *tmp = nullptr;
    PropertiesAttr changed_properties;
    bool obj_id_map_changed = false;

    std::lock_guard<std::mutex> lock(mutex_);
    changed_properties.clearChangedProperties();
    while (g_variant_iter_loop(iter, "{sv}", &key, &tmp)) {
        {% for prop_name, prop_info in user_def["properties"].items() %}
        {% if prop_info.iface == iface and prop_info.bustype == "session" %}
        if (std::string(key) == "{{prop_info.name}}") {
            {% if has_path_ids(prop_info) %}
            std::unordered_set<std::string> obj_paths = obj_id_map_[std::string(adk::{{get_const_string_attr(prop_name)}})];
            if (obj_paths.find(obj_path) == obj_paths.end()) {
                obj_paths.emplace(obj_path);
                obj_id_map_[std::string(adk::{{get_const_string_attr(prop_name)}})] == obj_paths;
                obj_id_map_changed = true;
            }
            {% endif %}
            {% if is_adk_type(adk_types, prop_info.type_desc.cpp_type) %}
            GVariantIter property_iter;
            g_variant_iter_init(&property_iter, tmp);
            {% if prop_info.type_desc.is_array == False %}
            changed_properties.set{{prop_name|upper_camel_case}}(dbus_->parse{{prop_info.type_desc.cpp_type|upper_camel_case}}(property_iter));
            {% else %}
            changed_properties.set{{prop_name|upper_camel_case}}(dbus_->parseArrayOf{{prop_info.type_desc.cpp_type|upper_camel_case}}(property_iter));
            {% endif %}
            {% else %}
            {% if prop_info.type_desc.is_array == True %}
            GVariantIter property_iter;
            g_variant_iter_init(&property_iter, tmp);
            changed_properties.set{{prop_name|upper_camel_case}}(dbus_->parseArrayOf{{prop_info.type_desc.cpp_type.rstrip("_t")|remove_namespace_from_type|upper_camel_case}}(property_iter));
            {% else %}
            {% if "string" in prop_info.type_desc.cpp_type %}
            gsize length;
            changed_properties.set{{prop_name|upper_camel_case}}(static_cast<std::string>(g_variant_get_string(tmp, &length)));
            {% else %}
            changed_properties.set{{prop_name|upper_camel_case}}({{get_g_variant_type_api(prop_info.type_desc.cpp_type)}}(tmp));
            {% endif %}
            {% endif %}
            {% endif %}
            continue;
        }
        {% endif %}
        {% endfor %}
    }

    if (tmp) {
        g_variant_unref(tmp);
    }
    if (obj_id_map_changed) {
        for (auto &f : obj_id_map_changed_listeners_) {
            f(obj_id_map_);
        }
    }
    return changed_properties;
}
{% endfor %}

{% for prop_name, prop_info in user_def["properties"].items() %}
{% if prop_info.bustype == "session" %}
std::tuple<ErrorCode, {{prop_info.type_desc.complete_cpp_type()}}> PropertiesHandler::read{{prop_name|upper_camel_case}}({% if has_path_ids(prop_info) %}const std::string &obj_id{% endif %}) {
    ErrorCode result = ADK_SI_OK;
    GVariant * response = nullptr;
    {{prop_info.type_desc.complete_cpp_type()}} {{prop_name|lower_snake_case}};
    std::tie(result, response) = dbus_->propertyGet(
        adk::dbus::{{get_const_string_def(svc=prop_info.svc)}},
        {% if has_path_ids(prop_info) %}
        obj_id.c_str(),
        {% else %}
        adk::dbus::{{get_const_string_def(obj_path=prop_info.obj_path)}},
        {% endif %}
        g_variant_new("(ss)",
            adk::dbus::{{get_const_string_def(iface=prop_info.iface)}},
            "{{prop_info.name}}"));

    if (result == ADK_SI_OK && response) {
        GVariant *tmp;
        g_variant_get(response, "(v)", &tmp);
        {% if is_adk_type(adk_types, prop_info.type_desc.cpp_type) %}
        GVariantIter property_iter;
        g_variant_iter_init(&property_iter, tmp);
        {% if prop_info.type_desc.is_array == False %}
        {{prop_name|lower_snake_case}} = dbus_->parse{{prop_info.type_desc.cpp_type|upper_camel_case}}(property_iter);
        {% else %}
        {{prop_name|lower_snake_case}} = dbus_->parseArrayOf{{prop_info.type_desc.cpp_type|upper_camel_case}}(property_iter);
        {% endif %}
        {% else %}
        {% if prop_info.type_desc.is_array == True %}
        GVariantIter property_iter;
        g_variant_iter_init(&property_iter, tmp);
        {{prop_name|lower_snake_case}} = dbus_->parseArrayOf{{prop_info.type_desc.cpp_type.rstrip("_t")|remove_namespace_from_type|upper_camel_case}}(property_iter);
        {% else %}
        {% if "string" in prop_info.type_desc.cpp_type %}
        gsize length;
        {{prop_name|lower_snake_case}} = static_cast<std::string>(g_variant_get_string(tmp, &length));
        {% else %}
        {{prop_name|lower_snake_case}} = {{get_g_variant_type_api(prop_info.type_desc.cpp_type)}}(tmp);
        {% endif %}
        {% endif %}
        {% endif %}
        g_variant_unref(tmp);
    }
    return std::make_tuple(result, {{prop_name|lower_snake_case}});
}

{% if prop_info.is_writable == 1 %}
ErrorCode PropertiesHandler::update{{prop_name|upper_camel_case}}(
    {{prop_info.type_desc.complete_cpp_type()}} {{prop_name|lower_snake_case}}{% if has_path_ids(prop_info) %},
    const std::string &obj_id
    {% endif %}) {
    {% if prop_info.type_desc.is_array == True %}
    GVariantBuilder {{prop_name|lower_snake_case}}_builder;
    g_variant_builder_init(&{{prop_name|lower_snake_case}}_builder, G_VARIANT_TYPE_ARRAY);
    for (auto &i : {{prop_name|lower_snake_case}}) {
        {% if prop_info.type_desc.dbus_fmt == "ab" %}
        g_variant_builder_add(&{{prop_name|lower_snake_case}}_builder, "b", static_cast<uint8_t>(i));
        {% elif prop_info.type_desc.dbus_fmt == "as" %}
        g_variant_builder_add(&{{prop_name|lower_snake_case}}_builder, "s", i.c_str());
        {% elif not is_adk_type(adk_types, prop_info.type_desc.cpp_type) %}
        g_variant_builder_add(&{{prop_name|lower_snake_case}}_builder, "{{prop_info.type_desc.dbus_fmt[1:]}}", i);
        {% endif %}
    }
    {% endif %}

    ErrorCode result = ADK_SI_OK;
    GVariant * response = nullptr;
    std::tie(result, response) = dbus_->propertySet(
        adk::dbus::{{get_const_string_def(svc=prop_info.svc)}},
        {% if has_path_ids(prop_info) %}
        obj_id.c_str(),
        {% else %}
        adk::dbus::{{get_const_string_def(obj_path=prop_info.obj_path)}},
        {% endif %}
        g_variant_new("(ssv)",
            adk::dbus::{{get_const_string_def(iface=prop_info.iface)}},
            "{{prop_info.name}}",
            {% if prop_info.type_desc.is_array == False %}
            {% if prop_info.type_desc.dbus_fmt == "b" %}
            g_variant_new("b", static_cast<uint8_t>({{prop_name|lower_snake_case}}))
            {% elif prop_info.type_desc.dbus_fmt == "s" %}
            g_variant_new("s", {{prop_name|lower_snake_case}}.c_str())
            {% elif not is_adk_type(adk_types, prop_info.type_desc.cpp_type) %}
            g_variant_new("{{prop_info.type_desc.dbus_fmt}}", {{prop_name|lower_snake_case}})
            {% endif %}
            {% else %}
            g_variant_new("{{prop_info.type_desc.dbus_fmt}}", &{{prop_name|lower_snake_case}}_builder)
            {% endif %}));
    return result;
}
{% endif %}
{% endif %}
{% endfor %}


MethodsHandler::MethodsHandler(Dbus *dbus) : dbus_(dbus) {
    dbus_->setPropertiesChangedListener(
        std::bind(&MethodsHandler::interfacesAddedCb, this,
        std::placeholders::_1, std::placeholders::_2, std::placeholders::_3));
}

void MethodsHandler::interfacesAddedCb(const std::string &obj_path,
    const std::string &iface_name, GVariantIter * /*iter*/) {
    g_print("MethodsHandler::interfacesAddedCb \n");

    bool obj_id_map_changed = false;
    std::lock_guard<std::mutex> lock(mutex_);
    {% for iface in get_dyn_ifaces(user_def["methods"]) %}
    if (iface_name == std::string(adk::dbus::{{get_const_string_def(iface=iface)}})) {
        {% for meth_name, meth_info in user_def["methods"].items() %}
        {% if meth_info.iface == iface and has_path_ids(meth_info) %}
        std::unordered_set<std::string> {{meth_name|lower_camel_case}}_obj_paths = obj_id_map_[std::string(adk::{{get_const_string_attr(meth_name)}})];
        if ({{meth_name|lower_camel_case}}_obj_paths.find(obj_path) == {{meth_name|lower_camel_case}}_obj_paths.end()) {
            {{meth_name|lower_camel_case}}_obj_paths.emplace(obj_path);
            obj_id_map_[std::string(adk::{{get_const_string_attr(meth_name)}})] = {{meth_name|lower_camel_case}}_obj_paths;
            obj_id_map_changed = true;
        }
        {% endif %}
        {% endfor %}
    }
    {% endfor %}

    if (obj_id_map_changed) {
        for (auto &f : obj_id_map_changed_listeners_) {
            f(obj_id_map_);
        }
    }
}

{% for method, method_info in user_def["methods"].items() %}
{% if method_info.out_args.len() == 1 %}
std::tuple<ErrorCode, {{method_info.out_args.at(0).complete_cpp_type()}}>
{% elif method_info.out_args.len() > 1 %}
std::tuple<ErrorCode, {{method|upper_camel_case}}Out>
{% else %}
ErrorCode
{% endif %}
MethodsHandler::{{method|lower_camel_case}}(
    {% if method_info.in_args.len() == 1 %}
    {{method_info.in_args.at(0).complete_cpp_type()}} in_arg
    {% elif method_info.in_args.len() > 1 %}
    {{method|upper_camel_case}}In in_arg
    {% endif %}
    {% if has_path_ids(method_info) %}{% if method_info.in_args.len() > 0 %},{% endif %}
    const std::string &obj_id
    {% endif %}) {
    {% if method_info.in_args.len() > 0 %}
    GVariantBuilder input_builder;
    {% if method_info.bustype == "address" %}
    g_variant_builder_init(&input_builder, G_VARIANT_TYPE("(({{method_info.in_arg_dbus_fmt}}))"));
    g_variant_builder_open(&input_builder, G_VARIANT_TYPE("({{method_info.in_arg_dbus_fmt}})"));
    {% elif method_info.bustype == "session"%}
    g_variant_builder_init(&input_builder, G_VARIANT_TYPE("({{method_info.in_arg_dbus_fmt}})"));
    {% endif %}
    {% if method_info.in_args.len() > 1 %}
    {% for in_arg in method_info.in_order %}
    {% set in_arg_info = method_info.in_args[in_arg] %}
    {% if not is_adk_type(adk_types, in_arg_info.cpp_type) %}
    {% if in_arg_info.is_array == True %}
    g_variant_builder_open (&input_builder, G_VARIANT_TYPE("{{in_arg_info.dbus_fmt}}"));
    for (auto &i : in_arg.get{{in_arg}}()) {
        {% if in_arg_info.is_dict == True %}
        {{in_arg_info.key_type}} key = i.first;
        {{in_arg_info.cpp_type}} value = i.second;
        g_variant_builder_open(&input_builder, G_VARIANT_TYPE("{{in_arg_info.dbus_fmt[1:]}}"));
        {% if "string" in in_arg_info.key_type %}
        g_variant_builder_add(&input_builder, "s", key.c_str());
        {% else %}
        g_variant_builder_add(&input_builder, "{{in_arg_info.dbus_fmt[2]}}", key);
        {% endif %}
        {% if "string" in in_arg_info.cpp_type %}
        g_variant_builder_add(&input_builder, "s", value.c_str());
        {% else %}
        g_variant_builder_add(&input_builder, "{{in_arg_info.dbus_fmt[3]}}", value);
        {% endif %}
        g_variant_builder_close(&input_builder);
        {% elif in_arg_info.dbus_fmt == "as" %}
        g_variant_builder_add(&input_builder, "s", i.c_str());
        {% else %}
        g_variant_builder_add(&input_builder, "{{in_arg_info.dbus_fmt[1:]}}", i);
        {% endif %}
    }
    g_variant_builder_close(&input_builder);
    {% if method_info.bustype == "address" %}
    g_variant_builder_close(&input_builder);
    {% endif %}
    {% elif in_arg_info.dbus_fmt == "b" %}
    g_variant_builder_add(&input_builder, "b", static_cast<uint8_t>(in_arg.get{{in_arg}}()));
    {% elif in_arg_info.dbus_fmt == "s" %}
    std::string {{in_arg|lower_snake_case}}_str = in_arg.get{{in_arg}}();
    g_variant_builder_add(&input_builder, "s", {{in_arg|lower_snake_case}}_str.c_str());
    {% else %}
    g_variant_builder_add(&input_builder, "{{in_arg_info.dbus_fmt}}", in_arg.get{{in_arg}}());
    {% endif %}
    {% endif %}
    {% endfor %}
    {% elif method_info.in_args.len() == 1 %}
    {% set in_arg = method_info.in_args.keys()[0] %}
    {% set in_arg_info = method_info.in_args.at(0) %}
    {% if not is_adk_type(adk_types, in_arg_info.cpp_type) %}
    {% if in_arg_info.is_array == True %}
    g_variant_builder_open (&input_builder, G_VARIANT_TYPE("{{in_arg_info.dbus_fmt}}"));
    for (auto &i : in_arg) {
        {% if in_arg_info.is_dict == True %}
        {{in_arg_info.key_type}} key = i.first;
        {{in_arg_info.cpp_type}} value = i.second;
        g_variant_builder_open(&input_builder, G_VARIANT_TYPE("{{in_arg_info.dbus_fmt[1:]}}"));
        {% if "string" in in_arg_info.key_type %}
        g_variant_builder_add(&input_builder, "s", key.c_str());
        {% else %}
        g_variant_builder_add(&input_builder, "{{in_arg_info.dbus_fmt[2]}}", key);
        {% endif %}
        {% if "string" in in_arg_info.cpp_type %}
        g_variant_builder_add(&input_builder, "s", value.c_str());
        {% else %}
        g_variant_builder_add(&input_builder, "{{in_arg_info.dbus_fmt[3]}}", value);
        {% endif %}
        g_variant_builder_close(&input_builder);
        {% elif in_arg_info.dbus_fmt == "ab" %}
        g_variant_builder_add(&input_builder, "b", static_cast<uint8_t>(i));
        {% elif in_arg_info.dbus_fmt == "as" %}
        g_variant_builder_add(&input_builder, "s", i.c_str());
        {% else %}
        g_variant_builder_add(&input_builder, "{{in_arg_info.dbus_fmt[1:]}}", i);
        {% endif %}
    }
    g_variant_builder_close(&input_builder);
    {% elif in_arg_info.dbus_fmt == "b" %}
    g_variant_builder_add(&input_builder, "b", static_cast<uint8_t>(in_arg));
    {% elif in_arg_info.dbus_fmt == "s" %}
    g_variant_builder_add(&input_builder, "s", in_arg.c_str());
    {% else %}
    g_variant_builder_add(&input_builder, "{{in_arg_info.dbus_fmt}}", in_arg);
    {% endif %}
    {% endif %}
    {% endif %}
    {% endif %}

    ErrorCode result = ADK_SI_OK;
    GVariant *response = nullptr;
    {% if method_info.bustype == "session" %}
    std::tie(result, response) = dbus_->gdbusMethodCall(adk::dbus::{{get_const_string_def(svc=method_info.svc)}},
        {% if has_path_ids(method_info) %}
        obj_id,
        {% else %}
        adk::dbus::{{get_const_string_def(obj_path=method_info.obj_path)}},
        {% endif %}
        adk::dbus::{{get_const_string_def(iface=method_info.iface)}},
        "{{method_info.name}}",
        {% if method_info.in_args.len() > 0 %}
        g_variant_builder_end(&input_builder)
        {% else %}
        nullptr
        {% endif %});
    {% elif method_info.bustype == "address" %}
    std::tie(result, response) = dbus_->gdbusAddressMethodCall(
        "unix:path=/var/run/pulse/dbus-socket",
        adk::dbus::{{get_const_string_def(svc=method_info.svc)}},
        {% if has_path_ids(method_info) %}
        obj_id,
        {% else %}
        adk::dbus::{{get_const_string_def(obj_path=method_info.obj_path)}},
        {% endif %}
        adk::dbus::{{get_const_string_def(iface=method_info.iface)}},
        "{{method_info.name}}",
        {% if method_info.in_args.len() > 0 %}
        g_variant_builder_end(&input_builder)
        {% else %}
        nullptr
        {% endif %});
    {% endif %}
    {% if method_info.out_args.len() == 0 %}
        return result;
    {% endif %}
    {% if method_info.out_args.len() > 0 %}
    {% if method_info.out_args.len() == 1 %}
    {% if "string" in method_info.out_args.at(0).cpp_type %}
    char * {{method|lower_snake_case}}_out;
    {% else %}
    {{method_info.out_args.at(0).complete_cpp_type()}} {{method|lower_snake_case}}_out;
    {% endif %}
    {% elif method_info.out_args.len() > 1 %}
    {{method|upper_camel_case}}Out {{method|lower_snake_case}}_out;
    {% endif %}
    if (result == ADK_SI_OK && response) {
        if (!g_variant_is_of_type(response, (const GVariantType *)"({{method_info.out_arg_dbus_fmt}})")) {
            return std::make_tuple(ADK_SI_ERROR_FAILED, {{method|lower_snake_case}}_out);
        }

        {% if method_info.out_args.len() == 1 %}
        {% set out_arg = method_info.out_args.keys()[0] %}
        {% set out_arg_info = method_info.out_args.at(0) %}
        {% if is_adk_type(adk_types, out_arg_info.cpp_type) %}
        GVariantIter *iter;
        g_variant_get(response, "({{method_info.out_arg_dbus_fmt}})", &iter);
        {% if out_arg_info.is_array %}
        {{method|lower_snake_case}}_out = dbus_->parseArrayOf{{out_arg_info.cpp_type|upper_camel_case}}(*iter);
        {% else %}
        {{method|lower_snake_case}}_out = dbus_->parse{{out_arg_info.cpp_type|upper_camel_case}}(*iter);
        {% endif %}
        {% else %}
        {% if out_arg_info.is_array %}
        {{method|lower_snake_case}}_out = dbus_->parseArrayOf{{out_arg_info.cpp_type.rstrip("_t")|remove_namespace_from_type|upper_camel_case}}(*iter);
        {% else %}
        g_variant_get(response, "({{out_arg_info.dbus_fmt}})", &{{method|lower_snake_case}}_out);
        {% endif %}
        {% endif %}
        {% elif method_info.out_args.len() > 1 %}
        {% for out_arg in method_info.out_order %}
        {% set out_arg_info = method_info.out_args[out_arg] %}
        {% if is_adk_type(adk_types, out_arg_info.cpp_type) or out_arg_info.is_array %}
        GVariantIter *{{out_arg}}_iter;
        {% elif "string" in out_arg_info.cpp_type %}
        gchar *{{out_arg}};
        {% else %}
        {{out_arg_info.cpp_type}} {{out_arg}};
        {% endif %}
        {% endfor %}

        g_variant_get(response, "({{method_info.out_arg_dbus_fmt}})"
        {% for out_arg, out_arg_info in method_info.out_args.items() %}
        {% if is_adk_type(adk_types, out_arg_info.cpp_type) or out_arg_info.is_array %}
        , &{{out_arg}}_iter
        {% else %}
        , &{{out_arg}}
        {% endif %}
        {% endfor %});

        {% for out_arg in method_info.out_order %}
        {% set out_arg_info = method_info.out_args[out_arg] %}
        {{method|lower_snake_case}}_out.set{{out_arg|upper_camel_case}}(
        {% if is_adk_type(adk_types, out_arg_info.cpp_type) %}
        {% if out_arg_info.is_array == True %}
        dbus_->parseArrayOf{{out_arg_info.cpp_type|upper_camel_case}}(*{{out_arg}}_iter));
        {% else %}
        dbus_->parse{{out_arg_info.cpp_type|upper_camel_case}}(*{{out_arg}}_iter));
        {% endif %}
        {% elif out_arg_info.is_array == True%}
        dbus_->parseArrayOf{{out_arg_info.cpp_type.rstrip("_t")|remove_namespace_from_type|upper_camel_case}}(*{{out_arg}}_iter));
        {% else %}
        {{out_arg}});
        {% endif %}
        {% endfor %}
        {% endif %}
    }
    return std::make_tuple(result, {{method|lower_snake_case}}_out);
    {% endif %}
}
{% endfor %}

SignalsHandler::SignalsHandler(Dbus *dbus) : dbus_(dbus) {
    {% for sig, sig_info in user_def["signals"].items() %}
    dbus_->set{{sig|upper_camel_case}}Listener(
        std::bind(&SignalsHandler::call{{sig|upper_camel_case}}Listeners, this,
        std::placeholders::_1, std::placeholders::_2));
    {% endfor %}
}

{% for sig, sig_info in user_def["signals"].items() %}
void SignalsHandler::call{{sig|upper_camel_case}}Listeners(const std::string &obj_path, GVariant* response) {
    g_print("SignalsHandler::call{{sig|upper_camel_case}}Listeners \n");
    {% if sig_info.args.len() > 0 %}
    if (!g_variant_is_of_type(response, (const GVariantType *)"({{sig_info.arg_dbus_fmt}})")) {
        return;
    }
    {% endif %}

    {% if sig_info.args.len() == 1 %}
    {% set arg = sig_info.args.keys()[0] %}
    {% set arg_info = sig_info.args.at(0) %}
    {% if is_adk_type(adk_types, arg_info.cpp_type) %}
    GVariantIter *iter;
    g_variant_get(response, "({{sig_info.arg_dbus_fmt}})", &iter);
    {% if arg_info.is_array %}
    {{arg_info.complete_cpp_type()}} {{sig|lower_snake_case}}_out = dbus_->parseArrayOf{{arg_info.cpp_type|upper_camel_case}}(*iter);
    {% else %}
    {{arg_info.cpp_type}} {{sig|lower_snake_case}}_out = dbus_->parse{{arg_info.cpp_type|upper_camel_case}}(*iter);
    {% endif %}
    {% else %}
    {% if arg_info.is_array %}
    {{arg_info.complete_cpp_type()}} {{sig|lower_snake_case}}_out = dbus_->parseArrayOf{{arg_info.cpp_type.rstrip("_t")|remove_namespace_from_type|upper_camel_case}}(*iter);
    {% else %}
    {% if "string" in arg_info.cpp_type %}
    char * {{sig|lower_snake_case}}_out;
    {% else %}
    {{arg_info,cpp_type}} {{sig|lower_snake_case}}_out;
    {% endif %}
    g_variant_get(response, "({{arg_info.dbus_fmt}})", &{{sig|lower_snake_case}}_out);
    {% endif %}
    {% endif %}
    for (auto &f : {{sig|lower_snake_case}}_listeners_) {
        f({{sig|lower_snake_case}}_out, obj_path);
    }
    {% elif sig_info.args.len() > 1 %}
    {{sig|upper_camel_case}}SigOut {{sig|lower_snake_case}}_out;

    {% for arg in sig_info.order %}
    {% set arg_info = sig_info.args[arg] %}
    {% if is_adk_type(adk_types, arg_info.cpp_type) or arg_info.is_array %}
    GVariantIter *{{arg}}_iter;
    {% elif "string" in arg_info.cpp_type %}
    gchar *{{arg}};
    {% else %}
    {{arg_info.cpp_type}} {{arg}};
    {% endif %}
    {% endfor %}

    g_variant_get(response, "({{sig_info.arg_dbus_fmt}})"
    {% for arg, arg_info in sig_info.args.items() %}
    {% if is_adk_type(adk_types, arg_info.cpp_type) or arg_info.is_array %}
    , &{{arg}}_iter
    {% else %}
    , &{{arg}}
    {% endif %}
    {% endfor %});

    {% for arg in sig_info.order %}
    {% set arg_info = sig_info.args[arg] %}
    {{sig|lower_snake_case}}_out.set{{arg|upper_camel_case}}(
    {% if is_adk_type(adk_types, arg_info.cpp_type) %}
    {% if arg_info.is_array == True %}
    dbus_->parseArrayOf{{arg_info.cpp_type|upper_camel_case}}(*{{arg}}_iter));
    {% else %}
    dbus_->parse{{arg_info.cpp_type|upper_camel_case}}(*{{arg}}_iter));
    {% endif %}
    {% elif arg_info.is_array == True%}
    dbus_->parseArrayOf{{arg_info.cpp_type.rstrip("_t")|remove_namespace_from_type|upper_camel_case}}(*{{arg}}_iter));
    {% else %}
    {{arg}});
    {% endif %}
    {% endfor %}
    for (auto &f : {{sig|lower_snake_case}}_listeners_) {
        f({{sig|lower_snake_case}}_out, obj_path);
    }
    {% elif sig_info.args.len() == 0 %}
    for (auto &f : {{sig|lower_snake_case}}_listeners_) {
        f(obj_path);
    }
    {% endif %}

}
{% endfor %}
}  // namespace adk
